Argus API Argus Camera API

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
DeFog.h
Go to the documentation of this file.
1 /*
2 * Copyright (c) 2016, NVIDIA CORPORATION. All rights reserved.
3 *
4 * Redistribution and use in source and binary forms, with or without
5 * modification, are permitted provided that the following conditions
6 * are met:
7 * * Redistributions of source code must retain the above copyright
8 * notice, this list of conditions and the following disclaimer.
9 * * Redistributions in binary form must reproduce the above copyright
10 * notice, this list of conditions and the following disclaimer in the
11 * documentation and/or other materials provided with the distribution.
12 * * Neither the name of NVIDIA CORPORATION nor the names of its
13 * contributors may be used to endorse or promote products derived
14 * from this software without specific prior written permission.
15 *
16 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
17 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
20 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
23 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
24 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
25 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
26 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
27 */
28
29 #ifndef _ARGUS_DE_FOG_H
30 #define _ARGUS_DE_FOG_H
31
32 namespace Argus
33 {
34
35 /**
36 * The Ext::DeFog extension adds an internal de-fog algorithm to
37 * the Argus driver. It introduces one new interface:
38 * - IDeFogSettings; used to enable de-fog for a Request.
39 */
40 DEFINE_UUID(ExtensionName, EXT_DE_FOG, 9cf05bd0,1d99,4be8,8732,75,99,55,7f,ed,3a);
41
42 namespace Ext
43 {
44
45 /**
46 * @class IDeFogSettings
47 *
48 * Request settings used to configure the de-fog algorithm.
49 */
50 DEFINE_UUID(InterfaceID, IID_DE_FOG_SETTINGS, 9cf05bd1,1d99,4be8,8732,75,99,55,7f,ed,3a);
51
52 class IDeFogSettings : public Interface
53 {
54 public:
55 static const InterfaceID& id() { return IID_DE_FOG_SETTINGS; }
56
57 /**
58 * Enables or disables de-fog.
59 * @param[in] enable whether or not de-fog is enabled.
60 */
61 virtual void setDeFogEnable(bool enable) = 0;
62
63 /**
64 * @returns whether or not de-fog is enabled.
65 */
66 virtual bool getDeFogEnable() const = 0;
67
68 /**
69 * Sets the amount of fog to be removed. Range 0.0 - 1.0 (none - all).
70 * @param[in] amount amount of fog to remove.
71 */
72 virtual Status setDeFogAmount(float amount) = 0;
73
74 /**
75 * @returns the amount of fog to remove.
76 */
77 virtual float getDeFogAmount() const = 0;
78
79 /**
80 * Set the quality of the effect, lower quality results in lower execution time.
81 * Range 0.0 - 1.0 (low quality - high quality).
82 * @param[in] quality effect quality.
83 */
84 virtual Status setDeFogQuality(float quality) = 0;
85
86 /**
87 * @returns the effect quality.
88 */
89 virtual float getDeFogQuality() const = 0;
90
91 protected:
92 ~IDeFogSettings() {}
93 };
94
95 } // namespace Ext
96
97 } // namespace Argus
98
99 #endif // _ARGUS_DE_FOG_H